var emailbody = "";
var default_linktext = "Click here to email results to Matt";
var linktext = default_linktext;

var pathtomaxfolder = "";

function maxfolder() {
	if (arguments.length == 0) {
		post("Error: no arguments to maxfolder message!");
	} else {
		pathtomaxfolder = arguments[0];
	}
}	

function clear() {
	emailbody = "";
}

function llll() {
	post('llll\n');
}

function setlinktext() {
	if (arguments.length == 0) {
		linktext = default_linktext;
	} else {
		linktext = "";
		for (i=0; i < arguments.length; ++i) {
			linktext = linktext + arguments[i] + " ";
		}
	}
}	



function apppath() {
		post(max.apppath+"\n");
}

function next_html_filename() {
	for (i=1; i<1000; ++i) {
		filename = "sendemail-" + i + ".html";
//		post(filename + "\n");

		var f = new File(":" + filename, "read");
		if (f.isopen) {
			// Yes, there was a file with that name
			f.close();
		} else {
			post("Next filename: " + filename + "\n");
			return filename;
		}
	}
	post("There seem to be a lot of HTML email files in your Max folder!");
	return("sendemail-n.html");
}

function done() {

  if (emailbody.length == 0) {
    post("text2email: text to be sent is still empty; can't send.\n");
    return;
  }

//	post(emailbody);
//	post();
//	window.open("mailto:matt@ccrma.stanford.edu?subject=listening test data&body= "+emailbody, 'email');
//	max.launchbrowser("mailto:matt@ccrma.stanford.edu?subject=listening test data&body= "+emailbody);


//	post("Email has length " + emailbody.length);
//	post("Email: " + emailbody + "\n");
	var escape1 = escape(emailbody);
	var escaped = escape1.replace(/%0A/g,"%0A\n");
//	post("escaped length is " + escaped.length);
//	post("Escaped: " + escaped + "\n");

//	var filename = "sendemail.html";
	var filename = next_html_filename();

  var slowness = 0;

  var f = new File(":"+filename,"write","HTML"); 

  if (f.isopen) {
    post("writing escaped text to file...\n");
    busy_wait(slowness);

    // Header
    f.writestring('<HTML><BODY><H1>');
    f.writestring('<A HREF="mailto:matt@ccrma.stanford.edu?subject=listening test data&body=');


    writebigstring(f, escaped);
    
    f.writestring('"> '+linktext+' </a></H1>');
    
    post("Writing form stuff...\n");
    busy_wait(slowness);

    // Andy's form method
    f.writestring("<hr>\n");
    f.writestring("If that doesn't work (which is likely on Windows), try this instead:\n");
    f.writestring('<form action="mailto:matt@cnmat.berkeley.edu?subject=listening test data" method="post"\n');
    f.writestring('<textarea name="\n');


    // BAD!!! f.writestring(emailbody);
    writebigstring(f, emailbody);

    f.writestring('">\n');
    f.writestring('</textarea> <input type="submit"></form>\n');
    f.writestring("<hr>\n");
    f.writestring("<p>If neither of the above work, your last resort is to open your\n");
    f.writestring("usual mail program manually and send this HTML file as an attachment.\n");
    f.writestring("This file is named " + filename + "\n");
    f.writestring("It's located in the same folder as the application for running this experiment.\n")
    f.writestring("If you're reading this in a web browser, it should be telling you \n");
    f.writestring("where on your computer's disk this file is located.</p>\n");
    
    // it's located in your \n");
    // .writestring("Max/MSP application folder:</p>\n");

    // f.writestring("<ul><li> Windows: /Program Files/Cycling '74/MaxMSP 4.6/</li>\n");
    // f.writestring("<li> Macintosh: /Applications/MaxMSP 4.6/ </li></ul>\n");

    f.writestring("<p>Use whichever of these three methods works best for you.</p>\n");
    f.writestring('</BODY></HTML>\n');

    f.close();

    // var fileURL = "file:" + escape(pathtomaxfolder + f.filename);
    var fileURLraw = "file:///" + (pathtomaxfolder + f.filename);
    var fileURL = fileURLraw.replace(/ /g, "%20");
    post("Opening " + fileURL + "\n");
    
    max.launchbrowser(fileURL);

  } else {
    post("could not create file: " + s + "\n");
  }

  emailbody = "";
}

function writebigstring(f, bigstring) {
    // Because of a Max limitation we can't call f.writestring() with a string longer 
    // than 2000 or maybe 256 characters, so we write it one line at a time...
    var a, z;
    a = 0;
    z = 0;
    while (z < bigstring.length) {
      // post("char: " + bigstring[z] + "\n");
      if (bigstring[z] == "\n") {
	var line = bigstring.slice(a,z);
	// post("Writing " + line.length  + " char line \n");
	f.writestring(line); //writes a string
	a = z;
      } 
      ++z;
    }
    
    if (a != bigstring.length-1) {
      // bgistring didn't end with a newline
      var line = bigstring.slice(a, bigstring.length-1);
      post("Writing last line, of length " + line.length + "\n");
      f.writestring(line); //writes a string
    }
}

function openurl() {
	if (arguments.length == 0) {
		post("Can't open nothing");
	} else {
		max.launchbrowser(arguments[0]);
	}
}

function set() {
	// This is what comes out of Text when you send "dump"

	for (i=0; i< arguments.length; ++i) {
		emailbody = emailbody + arguments[i] + " ";
	}
	emailbody = emailbody + "\n";
}

function foo() {
	max.launchbrowser("file:/tmp/foo.txt");
}

function busy_wait(ms) {
      if ( (ms == null) || (ms < 0)) {return;}

      var later = (new Date()).getTime() + ms;

      while(true){
         if ((new Date()).getTime() > later) {
            return;
         }
      } 
}